CREATE TABLE IF NOT EXISTS `#__ecboard_meta` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `version` varchar(100),
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__ecboard_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `alias` varchar(255),
  `description` varchar(200) NOT NULL,
  `image` varchar(100) DEFAULT NULL,
  `show_image` tinyint(1) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `created` timestamp NULL DEFAULT NULL,
  `modified` timestamp NULL DEFAULT NULL,
  `counter_posts` int(11) NOT NULL,
  `counter_threads` int(11) NOT NULL,
  `last_entry_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_entry_user_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `private` tinyint(1) NOT NULL DEFAULT '0',
  `moderated` tinyint(1) NOT NULL DEFAULT '0',
  `meta_title` varchar(255),
  `meta_description` varchar(255),
  `meta_keywords` varchar(255),
  `banner_top` text DEFAULT '',
  `banner_bottom` text DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1;


CREATE TABLE IF NOT EXISTS `#__ecboard_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT '0',
  `cat_id` int(11) NOT NULL DEFAULT '0',
  `thread` int(11) NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL DEFAULT '0',
  `account` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(100) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `ip` varchar(100) NOT NULL DEFAULT '',
  `type` int(11) NOT NULL DEFAULT 1,
  `subject` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) DEFAULT '',
  `message` text NOT NULL,
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `hits` int(11) NOT NULL DEFAULT '0',
  `locked` tinyint(1) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `counter_replies` int(11) NOT NULL DEFAULT '0',
  `last_entry_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_entry_user_id` int(11) NOT NULL,
  `last_entry_msg_id` int(11) NOT NULL,
  `sticky` tinyint(1) NOT NULL DEFAULT '0',
  `wfm` tinyint(1) DEFAULT '0',  
  `image1` varchar(255) DEFAULT '',
  `image1_description` varchar(255) DEFAULT '',
  `image2` varchar(255) DEFAULT '',
  `image2_description` varchar(255) DEFAULT '',
  `image3` varchar(255) DEFAULT '',
  `image3_description` varchar(255) DEFAULT '',
  `image4` varchar(255) DEFAULT '',
  `image4_description` varchar(255) DEFAULT '',
  `image5` varchar(255) DEFAULT '',
  `image5_description` varchar(255) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_thread` (`thread`),
  KEY `idx_sticky` (`sticky`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_parent_id` (`parent_id`),
  KEY `idx_cat_id` (`cat_id`),
  KEY `idx_last_entry_user_id` (`last_entry_user_id`),
  KEY `idx_last_entry_msg_id` (`last_entry_msg_id`),
  KEY `idx_published`  (`published`),
  KEY `idx_wfm`  (`wfm`),
  KEY `idx_date`  (`date`)
) ENGINE=MyISAM AUTO_INCREMENT=1;


CREATE TABLE IF NOT EXISTS `#__ecboard_users` (
  `id` int(11) NOT NULL,
  `username` varchar(150) DEFAULT '',
  `view` tinyint(1) NOT NULL DEFAULT '0',
  `ordering` tinyint(1) NOT NULL DEFAULT '0',
  `posts` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `avatar` varchar(100) DEFAULT '',
  `signature` text,
  `title` varchar(100) DEFAULT '',
  `zipcode` varchar(10) DEFAULT '',
  `city` varchar(100) DEFAULT '',
  `country` varchar(100) DEFAULT '',  
  `moderator` tinyint(1) NOT NULL DEFAULT '0',
  `moderated` tinyint(1) NOT NULL DEFAULT '0',
  `rookie` tinyint(1) NOT NULL DEFAULT '0',
  `trusted` tinyint(1) NOT NULL DEFAULT '0',
  `images` tinyint(1) NOT NULL DEFAULT '0',
  `files` tinyint(1) NOT NULL DEFAULT '0',
  `website` varchar(100) DEFAULT '',
  `twitter` varchar(100) DEFAULT '',
  `facebook` varchar(100) DEFAULT '',
  `flickr` varchar(100) DEFAULT '',
  `youtube` varchar(100) DEFAULT '',  
  `email_notification` tinyint(1) DEFAULT '0',
  `approval_notification` tinyint(1) DEFAULT '0',
  `show_online_status` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_moderator` (`moderator`)  
) ENGINE=MyISAM AUTO_INCREMENT=1;