<?php
 /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
 
defined( '_JEXEC' ) or die( 'Restricted access' );
$version = "1.3";
$componentInstaller =& JInstaller::getInstance();
$installer = new JInstaller();
$db =& JFactory::getDBO();

// check if Ecboard system plugin is already installed
$pathToPlgEcboardSystem = $componentInstaller->getPath('source') . DS . 'plugins' . DS . 'system';
$query = 'SELECT COUNT(*)' . ' FROM ' . $db->nameQuote('#__extensions')
			. ' WHERE ' . $db->nameQuote('element') . ' = ' . $db->Quote('ecboard')
			. ' AND ' . $db->nameQuote('type') . ' = ' . $db->Quote('plugin')
			. ' AND ' . $db->nameQuote('folder') . ' = ' . $db->Quote('system');
$db->setQuery($query);
$ecboardSystemPluginInstalled = (bool)$db->loadResult();

if ( $ecboardSystemPluginInstalled) {
	// upgrade the Ecboard system plugin
	if ( !$installer->install( $pathToPlgEcboardSystem)) { echo "Failed to upgrade the Ecboard system plugin!<br />"; } 
	else { echo "Successfully upgraded the Ecboard system plugin<br />"; } 
} else { 
	// install the Ecboard system plugin
	if ( !$installer->install( $pathToPlgEcboardSystem)) { echo "Failed to install the Ecboard system plugin!<br />"; } 
	else { echo "Successfully installed the Ecboard system plugin<br />"; } 
}

// enable Ecboard system plugin
$query = 'UPDATE ' . $db->nameQuote('#__extensions') . ' SET ' . $db->nameQuote('enabled') . ' = 1'
       	. ' WHERE ' . $db->nameQuote('element') . ' = ' . $db->Quote('ecboard')
       	. ' AND ' .   $db->nameQuote('type')  . ' = ' . $db->Quote('plugin')
       	. ' AND ' .   $db->nameQuote('folder')  . ' = ' . $db->Quote('system');
$db->setQuery($query);
if (!$db->query()) { echo "Failed to enable the Ecboard system plugin!<br />"; } 
else { echo "Successfully enabled the Ecboard system plugin<br />"; }

// check if Ecboard search plugin is already installed
$pathToPlgEcboardSearch = $componentInstaller->getPath('source') . DS . 'plugins' . DS . 'search'; 
$query = 'SELECT COUNT(*)' . ' FROM ' . $db->nameQuote('#__extensions')
			. ' WHERE ' . $db->nameQuote('element') . ' = ' . $db->Quote('ecboard')
			. ' AND ' . $db->nameQuote('type') . ' = ' . $db->Quote('plugin')
			. ' AND ' . $db->nameQuote('folder') . ' = ' . $db->Quote('search');
$db->setQuery($query);
$ecboardSearchPluginInstalled = (bool)$db->loadResult();

if ( $ecboardSearchPluginInstalled) {
	// upgrade the Ecboard search plugin
	if ( !$installer->install( $pathToPlgEcboardSearch)) { echo "Failed to upgrade the Ecboard search plugin!<br />"; } 
	else { echo "Successfully upgraded the Ecboard search plugin<br />"; } 
} else { 
	// install the Ecboard search plugin
	if ( !$installer->install( $pathToPlgEcboardSearch)) { echo "Failed to install the Ecboard search plugin!<br />"; } 
	else { echo "Successfully installed the Ecboard search plugin<br />"; }
}

// enabled Ecboard search plugin
$query = 'UPDATE ' . $db->nameQuote('#__extensions')
       	. ' SET ' . $db->nameQuote('enabled') . ' = 1'
       	. ' WHERE ' . $db->nameQuote('element') . ' = ' . $db->Quote('ecboard')
       	. ' AND ' .   $db->nameQuote('type')  . ' = ' . $db->Quote('plugin')
       	. ' AND ' .   $db->nameQuote('folder')  . ' = ' . $db->Quote('search');
$db->setQuery($query);
if (!$db->query()) { echo "Failed to enable the Ecboard search plugin!<br />"; } 
else { echo "Successfully enabled the Ecboard search plugin<br />"; }

// 1. get/set version information
$db->setQuery( 'SELECT COUNT(*) FROM `#__ecboard_meta`');
if ( $db->loadResult() == 0) { // no record found = fresh installation 
	$db->setQuery( "INSERT INTO `#__ecboard_meta` ( id, version) VALUES ('1', '" . $version . "')");
	$db->query(); 
} else { // upgrade 
	// get current version
	$db->setQuery( "SELECT version FROM `#__ecboard_meta` WHERE id='1'");
	$_version = $db->loadResult(); 
	switch ( $_version) { 
		case "1.0": { // upgrade 1.0 -> new version 
			echo "Upgrading from 1.0 to " . $version."<br />";
			// new fields						
			$sql = "ALTER TABLE `#__ecboard_users` ADD COLUMN `show_online_status` tinyint(1) DEFAULT '1'";
			$db->setQuery( $sql);
			$db->query();			
			// new indexes
			$sql = "ALTER TABLE `#__ecboard_messages` ADD INDEX `idx_published` (published)";
			$db->setQuery( $sql);
			$db->query();			
			$sql = "ALTER TABLE `#__ecboard_messages` ADD INDEX `idx_wfm` (wfm)";
			$db->setQuery( $sql);
			$db->query();			
			$sql = "ALTER TABLE `#__ecboard_messages` ADD INDEX `idx_date` (date)";
			$db->setQuery( $sql);
			$db->query();			
		}
		case "1.1": { // upgrade 1.1 -> new version
			echo "Upgrading from 1.1 to " . $version."<br />";
			// new fields						
			$sql = "ALTER TABLE `#__ecboard_categories` ADD COLUMN `meta_title` varchar(255) DEFAULT ''";
			$db->setQuery( $sql);
			$db->query();			
			$sql = "ALTER TABLE `#__ecboard_categories` ADD COLUMN `meta_description` varchar(255) DEFAULT ''";
			$db->setQuery( $sql);
			$db->query();			
			$sql = "ALTER TABLE `#__ecboard_categories` ADD COLUMN `meta_keywords` varchar(255) DEFAULT ''";
			$db->setQuery( $sql);
			$db->query();			
			$sql = "ALTER TABLE `#__ecboard_categories` ADD COLUMN `banner_top` text DEFAULT ''";
			$db->setQuery( $sql);
			$db->query();			
			$sql = "ALTER TABLE `#__ecboard_categories` ADD COLUMN `banner_bottom` text DEFAULT ''";
			$db->setQuery( $sql);
			$db->query();			
			break;
		}
		case "1.2": { // upgrade 1.2 -> new version
			echo "Upgrading from 1.2 to " . $version;
			echo "<br />";
			// new fields											
			break;
		}
		default: {
			break;
		}
	}
	// done. set new version
	$db->setQuery( "UPDATE `#__ecboard_meta` SET id='1', version='" . $version . "'");
	$db->query();
	echo "Upgrade done";
	echo "<br />";
}

// 2. if we are doing a new installation get all users from users table
$db->setQuery( 'SELECT COUNT(*) FROM `#__ecboard_users`');
if ( $db->loadResult() == 0) { // no records found = fresh installation
	$db->setQuery( "INSERT INTO `#__ecboard_users` ( id, username) SELECT id, username FROM `#__users` ORDER BY id ASC");
	$db->query();
}

// 3. if there are no forums -> install some sample data
$db->setQuery( 'SELECT COUNT(*) FROM `#__ecboard_categories`');
if ( $db->loadResult() == 0) { // no records found = fresh installation
	$sql = "INSERT INTO `#__ecboard_categories` ( id, parent_id, name, alias, description, show_image, published
			) VALUES ( '1', '0', 'Demo Container', '', 'Top level forums act like containers', '0', '1' )";
	$db->setQuery( $sql);
	$db->query();
	$sql = "INSERT INTO `#__ecboard_categories` ( id, parent_id, name, alias, description, show_image, published
			) VALUES ( '2', '1', 'Demo Forum', 'demo-forum', 'Demo Forum', '1', '1' )";
	$db->setQuery( $sql);
	$db->query();
}
echo "<br />Have fun with Ecboard " . $version."<br /><br />"; 