<?php /** 
 * @version        
 * @package        ecfirm
 * @subpackage    
 * @copyright    Copyright (C) 2011 Kilmeny.net. All rights reserved.
 * @license        GNU General Public License version 2 or later. 
 **/
 
defined( '_JEXEC' ) or die( 'Restricted access' ); 

function EcboardBuildRoute( &$query) { 
    $segments = array(); 
    unset( $query['view']); 
    if (isset( $query['task'])) { $segments[] = $query['task']; unset( $query['task']); } 
    if (isset( $query['catid'])) { $segments[] = $query['catid']; unset( $query['catid']); } 
    if (isset( $query['thread'])) { $segments[] = $query['thread']; unset( $query['thread']); } 
    if (isset( $query['parent'])) { $segments[] = $query['parent']; unset( $query['parent']); } 
    if (isset( $query['id'])) { $segments[] = $query['id']; unset( $query['id']); } 
    if (isset( $query['recent'])) { $segments[] = $query['recent']; unset( $query['recent']); }
    if (isset( $query['time'])) { $segments[] = $query['time']; unset( $query['time']); } 
    if (isset( $query['limitstart'])) { $segments[] = $query['limitstart']; unset( $query['limitstart']); } 
    if (isset( $query['catidto'])) { $segments[] = $query['catidto']; unset( $query['catidto']); } 
    if (isset( $query['userid'])) { $segments[] = $query['userid']; unset( $query['userid']); } 
    if (isset( $query['post'])) { $segments[] = $query['post']; unset( $query['post']); } 
    if (isset( $query['format'])) { $segments[] = $query['format']; unset( $query['format']); } 
    return $segments; 
}

function EcboardParseRoute( $segments) { 
    $vars = array(); 
    $count = count ( $segments);
    switch ( $count) { 
		case 1: {			
			switch ( $segments[0]) { 
				case 'profile': { $vars['view'] = "profile"; 				break; }		
				case 'approve':
				case 'createmsgaliases': { $vars['view'] = "moderation"; 	$vars['task']  = $segments[0]; break; } // task = approve/createmsgaliases
                case 'recent': { $vars['view'] = "recent"; $vars['task']  = $segments[0];  $vars['time']  = "24h";  break; } 
                // task = approve/createmsgaliases // default = 24h 
				case 'feed': { $vars['view']   = "index"; 				$vars['task']   = "feed"; $vars['format'] = "feed"; break; }		
				default: {	$vars['view'] = "category"; 			$vars['catid'] = $segments[0]; break; } 
				// category view // category slug
        	}
			break;
		}
		case 2: {			
			switch ( $segments[0]) { 
				case 'new': { $vars['view']  = "posting"; 				$vars['task']  = $segments[0];   $vars['catid'] = $segments[1];   break; }
				// task = new // category slug 
				case 'accept':
				case 'deny': { $vars['view']  = "moderation"; 				$vars['task']  = $segments[0];  $vars['post']  = $segments[1];  break; }
				// task = accept/deny  // post id
				case 'delete': { $vars['view']  = "moderation"; $vars['task']  = $segments[0];   $vars['post']  = $segments[1];   break; }		
				// task = delete // post = post id 
                case 'recent': { $vars['view'] = "recent"; $vars['task']  = $segments[0]; $vars['time']  = $segments[1];  break; }
                // task = approve/createmsgaliases // time = xxh 
				default: {	$vars['view']   = "thread"; 			$vars['catid']  = $segments[0];  $vars['thread'] = $segments[1];  break;		        	}
        		// category view // category slug // thread slug
        	} 
			switch ( $segments[1]) { 
				case 'feed': { $vars['view']   = "category"; $vars['task']   = "feed"; $vars['format'] = "feed"; break; }		
				 // category rss feed 
			} 
			break;
		}
		case 3: {			
			switch ( $segments[0]) {
				case 'move': { $vars['view'] = "moderation";  $vars['task'] = $segments[0];  $vars['catid']  = $segments[1]; 
						$vars['thread'] = $segments[2];   break; } // task = move // category slug // thread slug
				case 'sticky': 
				case 'unsticky': 
				case 'lock': 
				case 'unlock': { $vars['view']  = "moderation"; $vars['task'] = $segments[0];   $vars['catid']  = $segments[1]; 
						$vars['thread'] = $segments[2];   break; } // task = sticky/unsticky/lock/unlock // category slug // thread slug
				default: {break; }
        	} 
			break;
		} 
		case 4: {			
			switch ( $segments[0]) {
				case 'move': { $vars['view'] = "moderation"; $vars['task'] = $segments[0];   $vars['catid']   = $segments[1];   
				$vars['thread']  = $segments[2];   $vars['catidto'] = $segments[3];   break;}
				// task = move // category slug // thread slug // categoryto slug
				case 'reply': { $vars['view'] = "posting"; $vars['task']  = $segments[0]; $vars['catid'] = $segments[1];   
		        	$vars['thread']  = $segments[2];   $vars['parent']  = $segments[3];   break; }
				// task = reply // category slug // thread slug // parent ?
				default: {	break; }
        	}
			break;
		}
		case 5: {			
			switch ( $segments[0]) {
				case 'edit':
				case 'quote': { $vars['view']    = "posting"; $vars['task']    = $segments[0];   $vars['catid']   = $segments[1];   
		        	$vars['thread']  = $segments[2];   $vars['parent']  = $segments[3];   $vars['id']      = $segments[4];   break; }
				// task = edit/quote // category slug // thread slug // parent ? // id
				default: {break; }
        	}
			break;
		}
    	default: { break; }
    }
    return $vars; 
} 